"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var editorjs_1 = __importDefault(require("@editorjs/editorjs"));
var paragraph_1 = __importDefault(require("@editorjs/paragraph"));
var header_1 = __importDefault(require("@editorjs/header"));
var DEFAULT_ID = 'editorjs';
/**
 * EditorJs wraps editor.js in a React component and providing an API to be able
 * to interact with the editor.js instance.
 */
var EditorJs = function (props) {
    var deprecatedId = props.holderId, customHolderId = props.holder, editorInstance = props.editorInstance, reinitializeOnPropsChange = props.reinitializeOnPropsChange, children = props.children, tools = props.tools, otherProps = __rest(props, ["holderId", "holder", "editorInstance", "reinitializeOnPropsChange", "children", "tools"]);
    var instance = react_1.useRef(null);
    var holderId = deprecatedId || customHolderId || DEFAULT_ID;
    /**
     * initialise editorjs with default settings
     */
    var initEditor = react_1.useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!instance.current) {
                        instance.current = new editorjs_1.default(__assign({ tools: __assign({ paragraph: {
                                    class: paragraph_1.default,
                                    inlineToolbar: true,
                                }, header: header_1.default }, tools), holder: holderId }, otherProps));
                    }
                    if (!editorInstance) return [3 /*break*/, 2];
                    return [4 /*yield*/, instance.current.isReady];
                case 1:
                    _a.sent();
                    editorInstance(instance.current);
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); }, [editorInstance, holderId, otherProps, tools]);
    /**
     * destroy current editorjs instance
     */
    var destroyEditor = react_1.useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!instance.current) {
                        return [2 /*return*/, true];
                    }
                    return [4 /*yield*/, instance.current.isReady];
                case 1:
                    _a.sent();
                    instance.current.destroy();
                    instance.current = null;
                    return [2 /*return*/, true];
            }
        });
    }); }, [instance]);
    /**
     * initEditor on mount and destroy it on unmount
     */
    react_1.useEffect(function () {
        initEditor();
        return function () {
            destroyEditor();
        };
    }, []); // eslint-disable-line
    /**
     * when props change and reinitializeOnPropsChange is true, the component will
     * first destroy and then init EditorJS again.
     */
    react_1.useEffect(function () {
        var doEffect = function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!reinitializeOnPropsChange) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, destroyEditor()];
                    case 1:
                        _a.sent();
                        initEditor();
                        return [2 /*return*/];
                }
            });
        }); };
        doEffect();
    }, [destroyEditor, initEditor, instance, reinitializeOnPropsChange]);
    return children || react_1.default.createElement("div", { id: holderId });
};
exports.default = react_1.memo(EditorJs);
//# sourceMappingURL=editor.js.map